
Redmine - Defect #27884

RTL wiki class broken in Redmine 3.2.6

2018-01-03 11:09 - Hooman Valibeigi

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Text formatting Estimated time: 0.00 hour

Target version: 3.3.7   

Resolution: Fixed Affected version: 3.4.2

Description

The fix at #8121 is broken as stated in my last comment there.

My environment: Redmine 3.4.2, Google Chrome 63

1. `p(rtl).` maps to `class="wiki-class-rtl"` in html, but there is no such class in application.css

2. `unicode-bidi:bidi-override` must be removed or set to `normal`

See https://www.w3schools.com/cssref/pr_text_unicode-bidi.asp

Related issues:

Related to Redmine - Feature #8121: Allow overriding direction of part of text Closed 2011-04-10

Associated revisions

Revision 17260 - 2018-04-07 08:54 - Jean-Philippe Lang

Fix .rtl and .ltr css classes in formatted text broken by r16502 (#27884).

Revision 17261 - 2018-04-07 09:02 - Jean-Philippe Lang

Merged r17260 into 3.4-stable (#27884).

Revision 17262 - 2018-04-07 09:04 - Jean-Philippe Lang

Merged r17260 into 3.3-stable (#27884).

Revision 17280 - 2018-04-07 11:29 - Jean-Philippe Lang

Removes bidi-override in rtl/ltr wiki classes (#27884).

Revision 17281 - 2018-04-07 11:30 - Jean-Philippe Lang

Merged r17280 into 3.4-stable (#27884).

Revision 17282 - 2018-04-07 11:30 - Jean-Philippe Lang

Merged r17280 into 3.3-stable (#27884).

History

#1 - 2018-01-14 16:19 - Toshi MARUYAMA

- Target version set to 3.4.5

Hooman Valibeigi wrote:

The fix at #8121 is broken as stated in my last comment there.

My environment: Redmine 3.4.2, Google Chrome 63

1. `p(rtl).` maps to `class="wiki-class-rtl"` in html, but there is no such class in application.css

 I think we can change like r16503.

2. `unicode-bidi:bidi-override` must be removed or set to `normal`

See https://www.w3schools.com/cssref/pr_text_unicode-bidi.asp
 Which do you think is better?

#2 - 2018-01-17 14:14 - Hooman Valibeigi

Toshi MARUYAMA wrote:

Which do you think is better?

 Replacing the following lines in application.xml

.ltr {direction:ltr !important; unicode-bidi:bidi-override;}

.rtl {direction:rtl !important; unicode-bidi:bidi-override;}

with these, will fix it

.wiki-class-ltr {direction:ltr !important;}

.wiki-class-rtl {direction:rtl !important;}

#3 - 2018-01-17 14:19 - Hooman Valibeigi

It would be more appreciated if someone documents the syntax of `p(rtl).` on the wiki

https://www.redmine.org/projects/redmine/wiki/RedmineTextFormattingTextile

#4 - 2018-01-17 14:53 - Toshi MARUYAMA

Hooman Valibeigi wrote:

Toshi MARUYAMA wrote:

Which do you think is better?

 Replacing the following lines in application.xml

 Do you mean application.css, not application.xml?

#5 - 2018-01-17 16:14 - Hooman Valibeigi

Toshi MARUYAMA wrote:

Do you mean application.css, not application.xml?

 Yes, redmine/public/stylesheets/application.css

#6 - 2018-01-25 10:41 - Hooman Valibeigi

I've just noticed that HTML emails sent from Redmine will contain class="wiki-class-rtl" for RTL text, which is not supposed to work because email

clients have no access to Redmine css.

#7 - 2018-04-07 09:08 - Jean-Philippe Lang

- Subject changed from Support RTL Bidirection text to RTL wiki class broken in Redmine 3.2.6

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Target version changed from 3.4.5 to 3.3.7

- Resolution set to Fixed

The wiki class is fixed by r17260.

I've just noticed that HTML emails sent from Redmine will contain class="wiki-class-rtl" for RTL text, which is not supposed to work because

email clients have no access to Redmine css.

 Please open a separate issue as this problem is not specific the .rtl class.

#8 - 2018-04-07 11:11 - Hooman Valibeigi

2025-05-12 2/3

https://www.redmine.org/projects/redmine/wiki/RedmineTextFormattingTextile
https://www.redmine.org/projects/redmine/repository/svn/revisions/17260


Jean-Philippe Lang wrote:

The wiki class is fixed by r17260.

 You forgot to fix the unicode-bidi:bidi-override; value, must be unicode-bidi:normal; or left unset. bidi-override rotates the English words in a RTL

context, therefore word "cat" will be seen as "tac".

#9 - 2018-04-07 11:18 - Hooman Valibeigi

- Status changed from Closed to Reopened

#10 - 2018-04-07 11:27 - Jean-Philippe Lang

- Related to Feature #8121: Allow overriding direction of part of text added

#11 - 2018-04-07 11:31 - Jean-Philippe Lang

- Status changed from Reopened to Closed

bidi-override removed in r17280.
